/**
 * Created by Yuanhang on 2016/2/6.
 */
(function (window) {

    //定义EasyWeb
    var easyweb = {
        minVerCode: 101,
        IMAGE_QUALITY_NONE: 0,
        IMAGE_QUALITY_SMALL: 1,
        IMAGE_QUALITY_NORMAL: 2,
        IMAGE_QUALITY_LARGE: 3,
        IMAGE_QUALITY_XLARGE: 4
    };

    // 将WeixinApi暴露到window下：全局可使用，对旧版本向下兼容
    window.easyweb = easyweb;

    /**
     * 初始化配置
     */
    easyweb.init = function () {
        document.body.addEventListener('touchstart', function () { });//激活移动端active伪类
        $("img").each(function(){$(this).attr('src', $(this).attr('src'));});
    }

    /**
     * 退出
     */
    easyweb.logout = function (callback) {
        Cookies.remove('token', {path: '/', domain: 'appfly.cn'});
        if (typeof(Cookies.get('easyweb')) != "undefined" && parseInt(Cookies.get('easyweb')) >= easyweb.minVerCode) {
            prompt("easyweb://appfly.cn?target=logout");
        } else {
            window.location.href = "//appfly.cn/user/userLogout?callback=" + encodeURI(callback);
        }
    }

    /**
     *  检查code
     */
    easyweb.checkCode = function (data) {
        if (data["code"] == 11001 || data["code"] == 11002) {//未登录
            Cookies.remove('token', {path: '/', domain: 'appfly.cn'});
            swal("", "请先登录!", "warning", {timer: 1500});
            setTimeout(function(){
                easyweb.openUrl("//appfly.cn/user/userLogin?backOnCancel=1&type=class&action=cn.appfly.android.user.UserLoginActivity&callback=" + encodeURI(window.location.href));
            }, 2000);
            return -1;
        } else if (data["code"] == 11003) {//未绑定手机号
            swal("", "请绑定手机号!", "warning", {timer: 1500});
            setTimeout(function(){
                easyweb.openUrl("//appfly.cn/user/userPhoneBind?callback=" + encodeURI(window.location.href));
            }, 2000);
            return -1;
        } else if (data["code"] != 0) {
            swal("", data["message"], "error", {timer: 1500});
            return data["code"];
        }
        return 0;
    }

    /**
     * 检查token
     */
    easyweb.checkToken = function () {
        if ($("#token").length <= 0 && (typeof(Cookies.get('token')) == 'undefined' || Cookies.get('token').length <= 0)){
            swal("", "请先登录!", "warning", {timer: 1500});
            Cookies.remove('token', {path: '/', domain: 'appfly.cn'});
            setTimeout(function(){
                easyweb.openUrl("//appfly.cn/user/userLogin?backOnCancel=1&type=class&action=cn.appfly.android.user.UserLoginActivity&callback=" + encodeURI(window.location.href));
            }, 2000);
            return -1;
        }
        return 0;
    }

    /**
     * 打开指定页面
     * @param url
     * @returns {number}
     */
    easyweb.openUrl = function (url) {
        if (typeof(Cookies.get('easyweb')) != "undefined" && parseInt(Cookies.get('easyweb')) >= easyweb.minVerCode) {
            if (url.indexOf('?') > -1){
                window.location.href = url+"&target=blank";//跳转
            }else{
                window.location.href = url+"?target=blank";//跳转
            }
            return 1;
        }else{
            window.location.href = url;
            return 2;
        }
    }

    /**
     * 打开指定页面
     * @param url
     * @returns {number}
     */
    easyweb.openCloseUrl = function (url) {
        if (typeof(Cookies.get('easyweb')) != "undefined" && parseInt(Cookies.get('easyweb')) >= easyweb.minVerCode) {
            if (url.indexOf('?') > -1){
                window.location.href = url+"&target=close";//跳转
            }else{
                window.location.href = url+"?target=close";//跳转
            }
            return 1;
        }else{
            window.location.href = url;
            return 2;
        }
    }

    /**
     * 获取指定质量的图片URL
     * @param path
     * @param imageQuality
     * @returns {*}
     */
    easyweb.imageQualityUrl = function (path, imageQuality) {
        if (imageQuality === easyweb.IMAGE_QUALITY_NONE) {// 无图,返回空地址
            return "";
        } else if (path !== "") {
            //APPFLLY
            path = path.replace("img.appfly.cn", "f.appfly.cn");
            if (path.indexOf("f.appfly.cn") > -1) {
                if (path.indexOf("_") > -1 || path.indexOf("!") > -1) {
                    if (imageQuality === easyweb.IMAGE_QUALITY_SMALL) {
                        return path.replace("-normal", "-small");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_NORMAL) {
                        return path.replace("-normal", "-normal");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_LARGE) {
                        return path.replace("-normal", "-large");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_XLARGE) {
                        return path.replace("-normal", "-xlarge");
                    } else {
                        return path;
                    }
                } else {
                    if (imageQuality === easyweb.IMAGE_QUALITY_SMALL) {
                        return (path + "!img-small");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_NORMAL) {
                        return (path + "!img-normal");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_LARGE) {
                        return (path + "!img-large");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_XLARGE) {
                        return (path + "!img-xlarge");
                    } else {
                        return path;
                    }
                }
            }
            //ALICDN
            if ((path.indexOf("alicdn.com/imgextra") > -1 || path.indexOf("alicdn.com/bao/uploaded") > -1 || path.indexOf("alicdn.com/img/bao/uploaded") > -1 || path.indexOf("alicdn.com/img/ibank") > -1 || path.indexOf("taobaocdn.com/bao/uploaded") > -1 || path.indexOf("taobao.com/bao/uploaded") > -1 || path.indexOf("tbcdn.cn/tfscom") > -1)) {
                var end = '.jpg';
                var pattern = /_[1-9][0-9]*x[1-9][0-9]*(q[1-9][0-9])?.jpg/;
                if (pattern.test(path)) {
                    if (imageQuality === easyweb.IMAGE_QUALITY_SMALL) {
                        return path.replace(pattern, "_300x300q90" + end).replace("http://", "https://");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_NORMAL) {
                        return path.replace(pattern, "_600x600q90" + end).replace("http://", "https://");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_LARGE) {
                        return path.replace(pattern, "_800x800q90" + end).replace("http://", "https://");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_XLARGE) {
                        return path.replace(pattern, "_1200x1200q90" + end).replace("http://", "https://");
                    } else {
                        return path.replace("http://", "https://");
                    }
                } else {
                    if (imageQuality === easyweb.IMAGE_QUALITY_SMALL) {
                        return (path + "_300x300q90" + end).replace("http://", "https://");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_NORMAL) {
                        return (path + "_600x600q90" + end).replace("http://", "https://");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_LARGE) {
                        return (path + "_800x800q90" + end).replace("http://", "https://");
                    } else if (imageQuality === easyweb.IMAGE_QUALITY_XLARGE) {
                        return (path + "_1200x1200q90" + end).replace("http://", "https://");
                    } else {
                        return path.replace("http://", "https://");
                    }
                }
            }
        }
        return path;
    }

})(window);
